SHEBANG
# Copyright @BABOLO (C)2002,2003
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2004/08/11 08:48:48 yura Exp $

JNTROSTUP(ircd,,ircd-unrealdnl
,dnl
# jailup ${inclass} dir jailname jailaddr [user [group [port]]]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# 
#                                                   useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4:-10000}"
group="${5:-10000}"
port="${6:-6667}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
${up_mdir} "${conf_dir}" ${MTREE}-conf
${up_genlist} ./ ${MTREE}-conf | ${up_data} "${conf_dir}/" /usr/local/Unreal/
${up_genlist} etc/ ${MTREE}-conf | ${up_data} "${conf_dir}/" /usr/local/Unreal/
${up_genlist} usr/ ${MTREE} | ${up_data} "${main_dir}/usr/" /usr/local/Unreal/
ETCOPY(host.conf hosts protocols resolv.conf)
${up_shlib} "${main_dir}/usr/lib" << "EOF"
            z crypt c
EOF

${up_libexe} "${main_dir}/usr/libexec" << EOF
                   /usr/libexec/ld-elf.so.1
                   /usr/local/Unreal/ircd
EOF


      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
if  [ ! -e "${conf_dir}/group" ]; then
    ${cat} << "EOF" > "${conf_dir}/group"
wheel:*:0:root
ircd:*:10000:
nogroup:*:65533:
nobody:*:65534:
EOF
fi

if  [ ! -e "${conf_dir}/master.passwd" ]; then
    ${cat} << "EOF" > "${conf_dir}/master.passwd"
root:*:0:0::0:0:Charlie &:/:/nonexistent
ircd:*:10000:10000::0:0:ircd server:/:/sbin/nologin
nobody:*:65534:65534::0:0:Unprivileged user:/nonexistent:/nonexistent
EOF
fi

cf="unrealircd.conf"; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${sed} -e "s|%%ADMINEMAIL%%|${ADMINEMAIL}|" "${TEMPLATE}-server" > "${conf_dir}/${cf}"

      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${up_mtree} "${main_dir}" ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.				type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    protocols
    resolv.conf
    master.passwd		mode=0600
/set type=file uid=10000 gid=10000 mode=0644 flags=none
    unrealircd.conf
    badwords.channel.conf 
    badwords.message.conf 
    badwords.quit.conf 
    help.conf  
       aliases         type=dir  
           aliases.conf  
           anope.conf  
           auspice.conf
           cygnus.conf 
           epona.conf  
           generic.conf 
           genericstats.conf 
           ircservices.conf 
           operstats.conf 
        ..


..
EOF


${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"


${cat} << EOF >> "${genconfig}"
#${genclass}   ${inclass}      ${jdir} ${jailsname}    ${jailsaddr}    0       ${user} ${group}        ${port}
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
